detached-stash: introduce parse_flags_and_revs function
[git/dscho.git] / git-stash.sh
blob836d6e6f69fa2a82717a2f6d6bd69a95729c2467
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
11 or: $dashless clear"
13 SUBDIRECTORY_OK=Yes
14 OPTIONS_SPEC=
15 . git-sh-setup
16 require_work_tree
17 cd_to_toplevel
19 TMP="$GIT_DIR/.git-stash.$$"
20 trap 'rm -f "$TMP-*"' 0
22 ref_stash=refs/stash
24 if git config --get-colorbool color.interactive; then
25 help_color="$(git config --get-color color.interactive.help 'red bold')"
26 reset_color="$(git config --get-color '' reset)"
27 else
28 help_color=
29 reset_color=
32 no_changes () {
33 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
34 git diff-files --quiet --ignore-submodules
37 clear_stash () {
38 if test $# != 0
39 then
40 die "git stash clear with parameters is unimplemented"
42 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
43 then
44 git update-ref -d $ref_stash $current
48 create_stash () {
49 stash_msg="$1"
51 git update-index -q --refresh
52 if no_changes
53 then
54 exit 0
57 # state of the base commit
58 if b_commit=$(git rev-parse --verify HEAD)
59 then
60 head=$(git rev-list --oneline -n 1 HEAD --)
61 else
62 die "You do not have the initial commit yet"
65 if branch=$(git symbolic-ref -q HEAD)
66 then
67 branch=${branch#refs/heads/}
68 else
69 branch='(no branch)'
71 msg=$(printf '%s: %s' "$branch" "$head")
73 # state of the index
74 i_tree=$(git write-tree) &&
75 i_commit=$(printf 'index on %s\n' "$msg" |
76 git commit-tree $i_tree -p $b_commit) ||
77 die "Cannot save the current index state"
79 if test -z "$patch_mode"
80 then
82 # state of the working tree
83 w_tree=$( (
84 rm -f "$TMP-index" &&
85 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
86 GIT_INDEX_FILE="$TMP-index" &&
87 export GIT_INDEX_FILE &&
88 git read-tree -m $i_tree &&
89 git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
90 git write-tree &&
91 rm -f "$TMP-index"
92 ) ) ||
93 die "Cannot save the current worktree state"
95 else
97 rm -f "$TMP-index" &&
98 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
100 # find out what the user wants
101 GIT_INDEX_FILE="$TMP-index" \
102 git add--interactive --patch=stash -- &&
104 # state of the working tree
105 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
106 die "Cannot save the current worktree state"
108 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
109 test -s "$TMP-patch" ||
110 die "No changes selected"
112 rm -f "$TMP-index" ||
113 die "Cannot remove temporary index (can't happen)"
117 # create the stash
118 if test -z "$stash_msg"
119 then
120 stash_msg=$(printf 'WIP on %s' "$msg")
121 else
122 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
124 w_commit=$(printf '%s\n' "$stash_msg" |
125 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
126 die "Cannot record working tree state"
129 save_stash () {
130 keep_index=
131 patch_mode=
132 while test $# != 0
134 case "$1" in
135 -k|--keep-index)
136 keep_index=t
138 --no-keep-index)
139 keep_index=
141 -p|--patch)
142 patch_mode=t
143 keep_index=t
145 -q|--quiet)
146 GIT_QUIET=t
149 shift
150 break
153 echo "error: unknown option for 'stash save': $1"
154 echo " To provide a message, use git stash save -- '$1'"
155 usage
158 break
160 esac
161 shift
162 done
164 stash_msg="$*"
166 git update-index -q --refresh
167 if no_changes
168 then
169 say 'No local changes to save'
170 exit 0
172 test -f "$GIT_DIR/logs/$ref_stash" ||
173 clear_stash || die "Cannot initialize stash"
175 create_stash "$stash_msg"
177 # Make sure the reflog for stash is kept.
178 : >>"$GIT_DIR/logs/$ref_stash"
180 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
181 die "Cannot save the current status"
182 say Saved working directory and index state "$stash_msg"
184 if test -z "$patch_mode"
185 then
186 git reset --hard ${GIT_QUIET:+-q}
188 if test -n "$keep_index" && test -n $i_tree
189 then
190 git read-tree --reset -u $i_tree
192 else
193 git apply -R < "$TMP-patch" ||
194 die "Cannot remove worktree changes"
196 if test -z "$keep_index"
197 then
198 git reset
203 have_stash () {
204 git rev-parse --verify $ref_stash >/dev/null 2>&1
207 list_stash () {
208 have_stash || return 0
209 git log --format="%gd: %gs" -g "$@" $ref_stash --
212 show_stash () {
213 have_stash || die 'No stash found'
215 flags=$(git rev-parse --no-revs --flags "$@")
216 if test -z "$flags"
217 then
218 flags=--stat
221 w_commit=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
222 b_commit=$(git rev-parse --quiet --verify "$w_commit^") ||
223 die "'$*' is not a stash"
225 git diff $flags $b_commit $w_commit
229 # Parses the remaining options looking for flags and
230 # at most one revision defaulting to ${ref_stash}@{0}
231 # if none found.
233 # Derives related tree and commit objects from the
234 # revision, if one is found.
236 # stash records the work tree, and is a merge between the
237 # base commit (first parent) and the index tree (second parent).
239 # REV is set to the symbolic version of the specified stash-like commit
240 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
241 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
242 # s is set to the SHA1 of the stash commit
243 # w_commit is set to the commit containing the working tree
244 # b_commit is set to the base commit
245 # i_commit is set to the commit containing the index tree
246 # w_tree is set to the working tree
247 # b_tree is set to the base tree
248 # i_tree is set to the index tree
250 # GIT_QUIET is set to t if -q is specified
251 # INDEX_OPTION is set to --index if --index is specified.
252 # FLAGS is set to the remaining flags
254 # dies if:
255 # * too many revisions specified
256 # * no revision is specified and there is no stash stack
257 # * a revision is specified which cannot be resolve to a SHA1
258 # * a non-existent stash reference is specified
261 parse_flags_and_rev()
263 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
264 PARSE_CACHE="$*"
266 IS_STASH_LIKE=
267 IS_STASH_REF=
268 INDEX_OPTION=
270 w_commit=
271 b_commit=
272 i_commit=
273 w_tree=
274 b_tree=
275 i_tree=
277 REV=$(git rev-parse --no-flags --symbolic "$@" 2>/dev/null)
278 FLAGS=$(git rev-parse --no-revs -- "$@" 2>/dev/null)
280 set -- $FLAGS
282 FLAGS=
283 while test $# -ne 0
285 case "$1" in
286 -q|--quiet)
287 GIT_QUIET=-t
289 --index)
290 INDEX_OPTION=--index
296 FLAGS="${FLAGS}${FLAGS:+ }$1"
298 esac
299 shift
300 done
302 set -- $REV
304 case $# in
306 have_stash || die "No stash found."
307 set -- ${ref_stash}@{0}
313 die "Too many revisions specified: $REV"
315 esac
317 REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"
319 i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
320 set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
321 s=$1 &&
322 w_commit=$1 &&
323 b_commit=$2 &&
324 w_tree=$3 &&
325 b_tree=$4 &&
326 i_tree=$5 &&
327 IS_STASH_LIKE=t &&
328 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
329 IS_STASH_REF=t
333 is_stash_like()
335 parse_flags_and_rev "$@"
336 test -n "$IS_STASH_LIKE"
339 assert_stash_like() {
340 is_stash_like "$@" || die "'$*' is not a stash-like commit"
343 is_stash_ref() {
344 is_stash_like "$@" && test -n "$IS_STASH_REF"
347 assert_stash_ref() {
348 is_stash_ref "$@" || die "'$*' is not a stash reference"
351 apply_stash () {
352 applied_stash=
353 unstash_index=
355 while test $# != 0
357 case "$1" in
358 --index)
359 unstash_index=t
361 -q|--quiet)
362 GIT_QUIET=t
365 break
367 esac
368 shift
369 done
371 if test $# = 0
372 then
373 have_stash || die 'Nothing to apply'
374 applied_stash="$ref_stash@{0}"
375 else
376 applied_stash="$*"
379 # stash records the work tree, and is a merge between the
380 # base commit (first parent) and the index tree (second parent).
381 s=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
382 w_tree=$(git rev-parse --quiet --verify "$s:") &&
383 b_tree=$(git rev-parse --quiet --verify "$s^1:") &&
384 i_tree=$(git rev-parse --quiet --verify "$s^2:") ||
385 die "$*: no valid stashed state found"
387 git update-index -q --refresh &&
388 git diff-files --quiet --ignore-submodules ||
389 die 'Cannot apply to a dirty working tree, please stage your changes'
391 # current index state
392 c_tree=$(git write-tree) ||
393 die 'Cannot apply a stash in the middle of a merge'
395 unstashed_index_tree=
396 if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
397 test "$c_tree" != "$i_tree"
398 then
399 git diff-tree --binary $s^2^..$s^2 | git apply --cached
400 test $? -ne 0 &&
401 die 'Conflicts in index. Try without --index.'
402 unstashed_index_tree=$(git write-tree) ||
403 die 'Could not save index tree'
404 git reset
407 eval "
408 GITHEAD_$w_tree='Stashed changes' &&
409 GITHEAD_$c_tree='Updated upstream' &&
410 GITHEAD_$b_tree='Version stash was based on' &&
411 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
414 if test -n "$GIT_QUIET"
415 then
416 export GIT_MERGE_VERBOSITY=0
418 if git merge-recursive $b_tree -- $c_tree $w_tree
419 then
420 # No conflict
421 if test -n "$unstashed_index_tree"
422 then
423 git read-tree "$unstashed_index_tree"
424 else
425 a="$TMP-added" &&
426 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
427 git read-tree --reset $c_tree &&
428 git update-index --add --stdin <"$a" ||
429 die "Cannot unstage modified files"
430 rm -f "$a"
432 squelch=
433 if test -n "$GIT_QUIET"
434 then
435 squelch='>/dev/null 2>&1'
437 eval "git status $squelch" || :
438 else
439 # Merge conflict; keep the exit status from merge-recursive
440 status=$?
441 if test -n "$unstash_index"
442 then
443 echo >&2 'Index was not unstashed.'
445 exit $status
449 drop_stash () {
450 have_stash || die 'No stash entries to drop'
452 while test $# != 0
454 case "$1" in
455 -q|--quiet)
456 GIT_QUIET=t
459 break
461 esac
462 shift
463 done
465 if test $# = 0
466 then
467 set x "$ref_stash@{0}"
468 shift
470 # Verify supplied argument looks like a stash entry
471 s=$(git rev-parse --verify "$@") &&
472 git rev-parse --verify "$s:" > /dev/null 2>&1 &&
473 git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
474 git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
475 die "$*: not a valid stashed state"
477 git reflog delete --updateref --rewrite "$@" &&
478 say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
480 # clear_stash if we just dropped the last stash entry
481 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
484 apply_to_branch () {
485 have_stash || die 'Nothing to apply'
487 test -n "$1" || die 'No branch name specified'
488 branch=$1
490 if test -z "$2"
491 then
492 set x "$ref_stash@{0}"
494 stash=$2
496 git checkout -b $branch $stash^ &&
497 apply_stash --index $stash &&
498 drop_stash $stash
501 PARSE_CACHE='--not-parsed'
502 # The default command is "save" if nothing but options are given
503 seen_non_option=
504 for opt
506 case "$opt" in
507 -*) ;;
508 *) seen_non_option=t; break ;;
509 esac
510 done
512 test -n "$seen_non_option" || set "save" "$@"
514 # Main command set
515 case "$1" in
516 list)
517 shift
518 list_stash "$@"
520 show)
521 shift
522 show_stash "$@"
524 save)
525 shift
526 save_stash "$@"
528 apply)
529 shift
530 apply_stash "$@"
532 clear)
533 shift
534 clear_stash "$@"
536 create)
537 if test $# -gt 0 && test "$1" = create
538 then
539 shift
541 create_stash "$*" && echo "$w_commit"
543 drop)
544 shift
545 drop_stash "$@"
547 pop)
548 shift
549 if apply_stash "$@"
550 then
551 drop_stash "$applied_stash"
554 branch)
555 shift
556 apply_to_branch "$@"
559 case $# in
561 save_stash &&
562 say '(To restore them type "git stash apply")'
565 usage
566 esac
568 esac